#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
#include <owl\chooseco.h>
#include "pr26_1.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw : public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
  protected:
         TColor chosenColor;
         void CmChooseColor();
         void  Paint (TDC &paintDC, BOOL, TRect&);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_COMMAND(CM_CHOOSECOLOR, CmChooseColor),
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=GetSystemMetrics(SM_CXSCREEN)/3;
	Attr.H=GetSystemMetrics(SM_CXSCREEN)/4;
}

// TWndw::CmChooseColor()
//      Choose Color,
//    "".
void TWndw::CmChooseColor()
{
  //      .
  char errorMsg[81];
  //   TData   Color.
  TChooseColorDialog::TData colorData;
  //    
  //   Color. 
  static TColor customColors[16] =
  { 0x010101L, 0x101010L, 0x202020L, 0x303030L,
    0x404040L, 0x505050L, 0x606060L, 0x707070L,
    0x808080L, 0x909090L, 0xA0A0A0L, 0xB0B0B0L,
    0xC0C0C0L, 0xD0D0D0L, 0xE0E0E0L, 0xF0F0F0L
  };
  //    , 
  //   Color     
  //   .
  colorData.Flags = CC_FULLOPEN | CC_RGBINIT;
  //    . 
  colorData.Color = chosenColor;
  //     . 
  colorData.CustColors = customColors;
  //    Color.
  TChooseColorDialog *dialog =
       new TChooseColorDialog (this, colorData);
  //    Color. 
  int result = dialog->Execute();
  //    "OK"  .
  if (result == IDOK)
  {
      //  ,  .
      chosenColor = colorData.Color;
     //   . 
     Invalidate();
  }
  //   ... 
  else if (colorData.Error != 0)
  { //...    .
	wsprintf(errorMsg,"  #%ld.", colorData.Error);
   MessageBox(errorMsg, "",  MB_OK | MB_ICONEXCLAMATION);
  }
}

//TWndw::Paint()
//     Paint()  
// TWindow     WM_PAINT,  
// Windows  ,     
//  .
void TWndw::Paint(TDC &paintDC, BOOL, TRect&)
{
  //     .
  TPen *pen = new TPen(TColor::Black, 3, PS_SOLID);
  TBrush *brush = new TBrush(chosenColor);
  //        .
  paintDC.SelectObject (*pen); 
  paintDC.SelectObject (*brush);
  //    . 
  paintDC.Rectangle(50, 50, 200, 200);
  //     . 
  delete pen; 
  delete brush; 
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw= new TWndw(0,"  \" \"");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
